\section{\uppercase{Algebraic Background}}\label{sec:background}

Gröbner bases were introduced by Bruno Buchberger \cite{bb}, who named the
concept in honor of his advisor Wolfgang Gröbner (1899--1980). Buchberger also
developed the fundamental algorithm for the computation of a Gröbner basis known
as Buchberger's algorithm.

Gröbner bases are nowadays discussed in multiple books including \cite{gb} and
\cite{iva}. We will follow these books along the way as we gradually unveil the
elegance of Gröbner bases in solving systems of polynomial equations. Further
information can be also found in \cite{igb} and \cite{gbs}.

The set of all polynomials in $x_1, \ldots, x_n$ with coefficients in a field $\F$
will be denoted $\F\!\left[ x_1, \ldots, x_n \right]$. When the particular
variables are of no relevance, we will denote the set by $\F\!\left[\mathbf{x}
\right]$ for short. We will also employ the standard letters $x, y$ and $z$
instead of $x_1, x_2$ and $ x_3$ when we discuss illustrative polynomials.
Univariate polynomials will be denoted by $f\!\left( x \right) \in \F\!\left[ x
\right]$. We will denote by $\mathcal{M}\!\left( x_1, \ldots, x_n \right)$,
$\mathcal{M}(\mathbf{x})$ or simply $\mathcal{M}$, the set of all monomials in
the variables $x_1, \ldots, x_n$.

\begin{df}
  Let $h = \sum c_\alpha x^\alpha \in \F\!\left[\textbf{x} \right] \ \backslash \
  \{0\}$ be a nonzero polynomial, $F$ a subset of $\Fg \ \backslash \ \{0\}$ and
  let $\succeq$ be a monomial order on $\Mx$. The \textbf{multidegree} of $h$ is
  multideg($h$) = max($\alpha \in \mathbb{N}_0^n\ |\ c_\alpha \neq 0$). The maximum
  is taken with respect to $\succeq$. The \textbf{leading coefficient} of $h$ is
  LC($h$) = $c_{\text{multideg}\left( h \right)} \in \F$. $\LC{F} = \set*{\LC{f}
    \mid f \in F}$. The \textbf{leading monomial} of $h$ is LM($h$) =
  $x^{\text{multideg}\left( h \right)}$. The \textbf{leading term} of $h$ is
  LT($h$) = LC($h$) $\cdot$ LM($h$).
\end{df}
\begin{df}
  \label{df:basis}
  Let $\set*{f_1, \ldots, f_s} \subset \F\!\left[ \mathbf{x} \right]$ be a set of
  polynomials. Then we set
  \[
    \langle f_1, \ldots, f_s \rangle = \set*{\sum_{i=1}^s h_if_i~\bigg|~h_1, \ldots, h_s
      \in \F\!\left[ \mathbf{x} \right]}
  \]
  to be an ideal $I$ of $\F\!\left[ \mathbf{x} \right]$, where the set $\set*{f_1,
    \ldots, f_s}$ is a \textbf{basis} of $I$. We also call $\langle {f_1, \ldots,
    f_s} \rangle$ the \textbf{ideal generated by} $\set*{f_1, \ldots, f_s}$.
\end{df}
\begin{df}
  Let $I \subseteq \Fg$ be an ideal different from $\{0\}$. We denote by
  $\mathrm{LT}(I) = \{\mathrm{LT}(f) \mid f \in I\}$ the set of leading terms of
  nonzero elements of $I$. The \textbf{ideal of leading terms} of $I$, generated
  by $\mathrm{LT}(I)$, will be denoted by $\langle \mathrm{LT}(I) \rangle$.
\end{df}
\begin{df}
  Fix a monomial order on $\Mx$. A~finite basis $G \subseteq I$ of a nonzero ideal $I \subseteq
  \Fg$ is a \textbf{Gröbner basis} if
  \[
    \langle\LT{G} \rangle = \langle \LT{I} \rangle.
  \]
\end{df}
The definition above says that a set $\{\s[m]{g}\} \subseteq I$ is a Gröbner
basis if and only if the leading term of any element of $I$ is divisible by some
of the $\mathrm{LT}(g_i)$.
% Note that every ideal $I \subseteq \Fg$ has a Gröbner basis.
\begin{df}
  \label{df:red_gb}
  Let $G \subseteq I$ be a Gröbner basis of $I$. We call $G$ a \textbf{reduced Gröbner
    basis} if for all $g \in G$:
  \begin{enumerate}[label=(\roman*)]
  \item $\mathrm{LC}(g) = 1$.
  \item No monomial of $g$ is in $\langle \mathrm{LT}(G \  \backslash \ \{g\}) \rangle$.
  \end{enumerate}
\end{df}
Most computer algebra systems actually compute reduced Gröbner bases by default.
Any ideal has its reduced Gröbner basis and this basis is unique.

% When the second condition of Definition~\ref{df:red_gb} holds for a polynomial
% $g \in G$, we say that $g$ is fully reduced for $G$. We can obtain the reduced
% Gröbner basis as follows. Given $g \in G$, let $g' = \overline{g}^{G \backslash
%   \set*{g}}$ and let $G' = \left( G \backslash \{ g \} \right) \cup \set*{g'}$.
% Observe that $g'$ is fully reduced for $G'$. If we keep applying this process to
% all elements of $G$ until all of them are fully reduced, we end up with the
% reduced Gröbner basis.

\begin{df}
  Let $I = \langle \s[m]{f} \rangle \subseteq \Fx{x}$ be an ideal. The $l$-th \textbf{elimination
    ideal} $I_l$ is the ideal of $\F \! \left[ x_{l+1}, \ldots, x_n \right]$ given by
  $I_l = I \cap \F \! \left[ x_{l+1}, \ldots, x_n \right]$.
\end{df}

\begin{thm}[The Elimination Theorem]
  Let $G \subseteq I \subseteq \Fx{x}$ be a Gröbner basis of $I$ so that $x_1
  \succeq_{lex} x_2 \succeq_{lex} \cdots \succeq_{lex} x_n$, where $\succeq_{lex}$ is
  the lexicographic monomial order. Then, for every $0 \le l < n$, the set $G_l =
  G \cap \F \! \left[ x_{l+1}, \ldots, x_n \right]$ is a Gröbner basis of the
  $l$-th elimination ideal $I_l$.
\end{thm}

\begin{p}
  See \cite[p. 123]{iva}.
\end{p}

% ZAKOMENTOVANE Z DOVODU SETRENIA MIESTA
%\begin{p}
%  We know that $G_l \subseteq I_l$ by construction, so we only need to show that $\langle
%  \LT{I_l} \rangle = \langle \LT{G_l} \rangle$ for a fixed $l$ between 0 and $n$. The inclusion $\langle
%  \LT{I_l} \rangle \supseteq \langle \LT{G_l} \rangle$ is evident and to prove $\langle \LT{I_l} \rangle \subseteq \langle \LT{G_l}
%  \rangle$, we need to show that $\LT{g} \mid \LT{f}$ for an arbitrary $f \in I_l$ and some
%  $g \in G_l$.
%
%  We know that $f$ is also in $I$, so $\LT{g} \mid \LT{f}$ for some $g \in G$ since
%  $G$ is a Gröbner basis of $I$. Since $f \in I_l$, $\LT{g}$ must consist only of
%  $x_{l+1}, \ldots, x_n$. Now comes the crucial observation: since $x_1 \lex \cdots \lex
%  x_n$, any monomial involving any $\s[l]{x}$ is greater than all monomials in
%  $\F \! \left[ x_{l+1}, \ldots, x_n \right]$. We see that $g \in G_l$, which proves
%  the theorem.
%\end{p}

%% THIS WAS A PART OF THE PAPER !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
%Let us present the power of the Elimination Theorem on the following example.
%
%\begin{e}
%  \label{e:gr1}
%  Consider a system of equations $f_1 = f_2 = f_3 = 0$ where the polynomials in $\R
%  \! \left[ x, y, z \right]$ are as follows:
%
%\vspace{-0.5cm}
%
%  \begin{align*}
%    f_1 &= -16 x^2 - 4 x y^2 + 4 x z, \\
%    f_2 &= 4 x^2 z + 2 x y^2 z + z, \\
%    f_3 &= x y^2 + 2 y^2 z + 1. \\
%  \end{align*}
%
%\vspace{-0.5cm}
%
%  If we compute the reduced Gröbner basis with $z \succeq_{lex} y \succeq_{lex}
%  x$, we get the following polynomials:
%  \begin{align*}
%    g_1 &= x + \frac{1}{4} y^2 - \frac{1}{4} z, & g_3 &= y^2 z - \frac{1}{9} z^2,\\
%    g_2 &= y^4 - z^2 - 4, & g_4 &= z^3 + \frac{81}{20} z.
%  \end{align*}
%%    \begin{align*}
%%    g_1 &= x + \frac{1}{4} y^2 - \frac{1}{4} z, \\
%%    g_2 &= y^4 - z^2 - 4, \\
%%    g_3 &= y^2 z - \frac{1}{9} z^2, \\
%%    g_4 &= z^3 + \frac{81}{20} z.
%%  \end{align*}
%  We see that the last polynomial involves only the variable $z$ and that its
%  only solution in $\R$ is $z = 0$. We can now substitute this solution into
%  $g_3$ and $g_2$ and obtain two solutions, namely $y = \pm \sqrt{2}$. We can
%  proceed further and get $x = - \frac{1}{2}$. We see that the reduced Gröbner
%  basis allowed us to solve the system.
%\end{e}
%!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

\begin{df}
  Let $\F_q \! \left[ \s{x} \right]$ be a polynomial ring over the finite field
  $\F_q$ with order $q = p^m$ where $p$ is a prime number and $m \in \mathbb{N}_{>0}$. The
  \textbf{field equations} of $\F_q$ are the polynomials $x_i^q - x_i$ for every
  $x_i \in \{\s{x}\}$.
\end{df}

\begin{df}
  Let $\set*{f_1, \ldots, f_s} \subset \F\!\left[ x_1, \ldots, x_n \right]$ be a set
  of polynomials and $\F^n$ an affine space. The \textbf{affine variety}
  $V\!\left( f_1, \ldots, f_s \right)$ defined by $\set*{f_1, \ldots, f_s}$ is
  the set
  \begin{equation*}
    \resizebox{.9\hsize}{!}{$
      V\!\left( f_1, \ldots, f_s \right) = \set*{\mb{a} \in \F^n~\Big|~f_i\!\left( \mb{a} \right) = 0 \text{ for all } 1 \le i \le s}
    $}
  \end{equation*}
  of all roots of all the polynomials in $\set*{f_1, \ldots, f_s}$.
\end{df}

\begin{thm}[Finiteness Theorem]
  \sloppy Let $\s[m]{f} \in \Fx{x}$ be polynomials. If we have $\langle \s[m]{f}
  \rangle \cap \F \! \left[ x_i \right] \neq 0$ for all $x_i$, then $V(\langle \s[m]{f} \rangle)
  \subseteq \F^n$ is finite.
\end{thm}

\begin{p}
  See \cite[p. 252]{iva}.
\end{p}

Considering the Finiteness Theorem above, adding the field equations into our
polynomial system ensures that the system will have finitely many solutions.

\begin{thm}[Hilbert's Weak Nullstellensatz]
  Let $\s[m]{f} \in \Fg$ be polynomials. Then the following are equivalent:
  \begin{enumerate}[label=(\roman*)]
  \item There exists an extension field $\E$ of $\F$ and $\mathbf{a} \in \E^n$
    such that for all $f_i$ we have $f_i(\mathbf{a}) = 0$.
  \item $1 \notin \langle \s[m]{f} \rangle$.
  \end{enumerate}
\end{thm}

\begin{p}
  See \cite[p. 281]{gb}.
\end{p}

Note that $1 \in I \subseteq \Fg$, where $I$ is an ideal, means $I = \Fg$
since $1h = h$ for all $h \in \Fg$. Also note that whenever we have a finite
field $\F$ and its extension $\E$, all elements from $\F$ satisfy all of the
field equations of $\F$ and no element in $\E\ \backslash\ \F$ satisfies any of
these equations. Therefore, if we add the field equations into a polynomial
system that consists of polynomials in $\Fg$, we restrict our solutions to the
field $\F$. Let us demonstrate this fact in combination with the Hilbert's~Weak
Nullstellensatz on the following two examples.


\begin{e}
  \label{e:gr2}
  Consider a system of equations where $f_1 = f_2 = f_3 = 0$ are polynomials in
  GF(2) with
  \begin{align*}
    f_1 &= x + y + z, & f_2 &= x y + x z + y z, & f_3 &= x y z + 1.\\
  \end{align*}

\vspace{-0.5cm}

  If we compute the reduced Gröbner basis with $z \succeq_{lex} y \succeq_{lex}
  x$, we get the following polynomials:
  \begin{align*}
    g_1 &= x + y + z, & g_2 &= y^2 + y z + z^2, & g_3 &= z^3 + 1.\\
  \end{align*}

\vspace{-0.5cm}

We see that the only solution to the last polynomial is $z = 1$. When we
substitute this solution into $g_2$, we get $g_2' = y^2 + y + 1$, which has no
solution in GF(2), and therefore the initial polynomial system has no solution
in GF(2) either. Since $g_2'$ is irreducible over $\mathrm{GF}(2)$ we get the
extension field $\mathrm{GF}(2)[\alpha] / \langle \alpha^2+\alpha+1 \rangle =$
GF($2^2$) with the elements $0, 1, \alpha, \alpha + 1$. If $z = 1$, the
polynomial $g_2$ has two solutions in GF($2^2$), namely $y = \alpha$ and $y =
\alpha + 1$, since $(\alpha + 1)^2 = \alpha$. The polynomial $g_1$ has then also
two solutions in GF($2^2$), namely $x = \alpha$ and $x = \alpha + 1$. All of
these solutions also satisfy our initial system $f_1, f_2, f_3$. We could also
obtain further solutions if we set $z = \alpha$.
\end{e}

\begin{e}
  Considering the previous example, if we add the field equations of $\F$ into
  the system, we get the following reduced Gröbner basis:
  \begin{align*}
    g_1 &= 1.
  \end{align*}
  According to the Hilbert's~Weak Nullstellensatz, we can already see that the
  initial polynomial system $f_1, f_2, f_3$ has no solutions in GF(2).
\end{e}

One of the fastest and practically implementable algorithms for computing
Gröbner bases, i.e., F4, was introduced in \cite{f4}. The algorithm is
implemented in the computer algebra system Magma \cite{magma}, which we employ
in our experiments.
